<?php
/**
 * Given a uid, return a string representing the user's rank.
 * Thanks to Morbus (IRC) for this code
 */
function uieforum_user_rank($posts = NULL)
{
  global $user;
  if ($posts == NULL || !isset($user->uid)) { return NULL; }

  switch ($posts) {
    case $posts <= 10:  return 'n00b';
    case $posts <= 100:  return 'Killing Spree';
    case $posts <= 500:  return 'Rampage';
    case $posts <= 1000: return 'Dominating';
    case $posts <= 4000: return 'Unstoppable';
    case $posts <= 5000: return 'Godlike';
    case $posts <= 7000: return 'Wicked Sick';
    case $posts > 7000: return 'Oh Emm Gee';
  }
}

/** Returns the href link to a thread **/
function get_actual_thread_link($tid)
{
  static $vals = array();
  if(!$vals[$tid])
  {
    $vals[$tid] = "c=showthread&ThreadID=".$tid;
  }
  return $vals[$tid];
}

/** Returns the entire <a> html code for the current thread 
**/
function get_thread_link_text($t)
{
  static $vals = array();
  if(!$vals[$t->ThreadID])
  {
    $vals[$t->ThreadID] = l(get_thread_title($t), uieforum_get_module_menu_name(), null, get_actual_thread_link($t->ThreadID));
  }
  return $vals[$t->ThreadID];
}

/** Returns the link to the last post of a thread
**/
function get_thread_link_text_last_post($t, $objstr, $plus_initial=true)
{
  $numrows = $t->PostCount;
  $maxPage = uieforum_get_max_page_count($numrows);

  $actual_link = get_actual_thread_link($t->ThreadID);
  if($plus_initial) $var = l(t($objstr), uieforum_get_module_menu_name(), null, $actual_link."&page=".$maxPage."#lastpost", null, null, true);
  else $var = $actual_link;
  return $var;
}

function get_thread_title($t)
{
  return uieforum_filter('process', null, null, t($t->ThreadTitle));
}

/** Gets a user from their uid
**/
function get_user_from_id($ID)
{
  if(!is_numeric($ID))
    return false;

  static $vals = array();
  if(!$vals[$ID])
  {
    $query = db_query('SELECT * FROM {users} WHERE uid=%d', $ID);
    if ($Error = mysql_error())
    {
      echo "GetUserFromID: $Error";
      error_log("GetUserFromID: $q $Error");
    }
    $vals[$ID] =  mysql_fetch_object($query);
  }
  return $vals[$ID];
}

/** Returns the thread object that contains a specific post
**/
function get_thread_from_post($PostID)
{
  $query = db_query("SELECT F_Threads.* FROM F_Threads, F_Posts WHERE F_Posts.PostID=%d AND F_Threads.ThreadID=F_Posts.ThreadID", $PostID);
  if ($Error = mysql_error())
    echo "$Error";
  return mysql_fetch_object($query);
}

/** Returns the forum object that contains the thread, that contains a specific post
**/
function get_forum_from_post($PostID)
{
  $query = db_query("SELECT F_Forums.* FROM F_Forums, F_Threads, F_Posts WHERE F_Posts.PostID=%d AND F_Threads.ThreadID=F_Posts.ThreadID AND F_Forums.ForumID=F_Threads.ForumID", $PostID);
  if ($Error = mysql_error())
    echo "$Error";
  return mysql_fetch_object($query);
}

/** Returns the forum object that contains a specific thread
**/
function get_forum_from_thread($ThreadID)
{
  $query = db_query("SELECT F_Forums.* FROM F_Forums, F_Threads WHERE F_Threads.ThreadID=%d AND F_Forums.ForumID=F_Threads.ForumID", $PostID);
  if ($Error = mysql_error())
    echo "$Error";
  return mysql_fetch_object($query);
}

/**  Returns a thread object, that corresponds to a given thread id
**/
function get_thread($ThreadID)
{
  $query = db_query("SELECT F_Threads.* FROM F_Threads WHERE F_Threads.ThreadID=%d", $ThreadID);

  if ($Error = mysql_error())
    echo "$Error";
  return mysql_fetch_object($query);
}

/** Returns an array of threads that are contained withing a forum
*/
function get_threads_from_forum($fid, $orderby = true, $pagelimit = true)
{
  static $storageArray = array();

  if(!$storageArray[$fid])
  {
    $Threads = Array();
    $q  = "SELECT F_Threads.* FROM F_Threads WHERE F_Threads.ForumID=%d ";
    $q .= $orderby ? "ORDER BY F_Threads.Sticky DESC, F_Threads.LastPost DESC " : "";
    $q .= $pagelimit ? "LIMIT ".uieforum_get_pages_offest().", ".variable_get('forum_per_page', 25) : "";

    $query = db_query($q, $fid);

    $Threads = uieforum_to_array($query);
    $storageArray[$fid] = $Threads;
  }
  return $storageArray[$fid];
}

/** Returns an array of all threads
*/
function get_threads()
{
  $Threads = Array();
  $query = db_query("SELECT F_Threads.* FROM F_Threads");

  $Threads = uieforum_to_array($query);
  return $Threads;
}

/** Returns all forums that are within a forum. (that a user has access to)
**/
function get_forums($fid = null, $arr = false, $forcerecount = false, $includeThis = false)
{
  Global $user;
  static $storageArray = array();
  $storageArray = array();
  if(
      ($fid && !$storageArray[$fid])
   || ($forcerecount && (!$fid && !$storageArray[$fid]->ForceRecount) )
   || !$fid
    )
  {
    $Forums = Array();

    if($fid == null && !$forcerecount)
    {
      $limitsql = "SELECT * FROM F_Forums WHERE ParentForum is null OR ParentForum = 0 ";
    }
    else
    {
      if($arr)
      {
        sort($arr);
      }
      if($forcerecount)
      {
        $limitsql = "SELECT F_Forums.ForumID, F_Forums.ForumName, F_Forums.ParentForum, COUNT(DISTINCT(F_Threads.ThreadID)) AS ThreadCount, COUNT(DISTINCT(F_Posts.PostID)) AS PostCount, '' AS TotalPostCount, '' AS TotalThreadCount FROM F_Forums LEFT JOIN F_Threads ON F_Threads.ForumID=F_Forums.ForumID LEFT JOIN F_Posts ON F_Posts.ThreadID=F_Threads.ThreadID " . ( $includeThis ? "" : "WHERE F_Forums.ParentForum='%d'");
        $limitsql .= " GROUP BY F_Threads.ForumID";
        $limitsql .= " ORDER BY F_Forums.ForumID ASC";
//        $limitsql .= " ORDER BY weight, ForumName ASC";
      }
      else
      {
        $limitsql = "SELECT * FROM F_Forums WHERE F_Forums.ParentForum=%d";
        if($arr && sizeof($arr) > 0)
        {
          $limitsql .= " OR F_Forums.ParentForum IN (";
          $inStr = "";
          foreach($arr AS $a)
          {
            // As I don't know how to pass an _array_ of values into db_query, I have to hard code the query with the variables needed to check. (rather than using drupal's %d syntax) - zoro
            $inStr .= "'".$a."', ";
          }
          $inStr = substr($inStr, 0, strlen($inStr)-2) . ")";
          $limitsql .= $inStr . " OR F_Forums.ForumID='".$fid."'";
        }

        $limitsql .= get_allowed_forums();
        $limitsql .= " ORDER BY weight, ForumName ASC";
      }
    }

    if(!$fid || $forcerecount)
    {
      $query = db_query($limitsql);
    }
    else
    {
      $query = db_query($limitsql, $fid);
    }
    $Forums = uieforum_to_array($query, "ForumID");
    if($forcerecount)
    {
      $maxsize = sizeof($Forums);

      foreach($Forums AS $key => $val)
      {
        $Forums[$key]->ForceRecount = true;
      }
      return $Forums;
    }
    else
    {
      $storageArray[$fid] = $Forums;
    }
  }
  return $storageArray[$fid];
}

/** Returns a MYSQL string to be used to restrict a select statement to only those forums that a given user has access to
**/
function get_allowed_forums($fid = false)
{
   Global $user;
   static $basic;

   if(isset($basic)) return $basic;

   $Forums = Array();
   $allowed = array();
   $Forums = get_all_forums($fid);

   if(!user_access('administer '.uieforum_get_module_security_name()))
   {
     $temparr = Array();
     foreach($Forums as $f)
       $temparr[] = $f->ForumID;
     $groups = get_security_groups(1, $temparr);

     foreach($groups AS $ga)
     {
       if($ga->HasAccess > 0)
       {
         if(user_access($ga->GroupName))
         {
           $allowed[] = $ga->HasAccess;
         }
       }
     }
   }
   $alltext = "";
   if(sizeof($allowed) > 0)
   {
     $alltext = " AND F_Forums.ForumID IN(";
     foreach($allowed AS $all)
       $alltext .= "'".$all."', ";
     $alltext = substr($alltext, 0, strlen($alltext)-2).")";
   }
   if(!$fid) $basic = $alltext;
   return $alltext;
}

/** Returns the number of (direct) children that a forum has. This is NOT recursive
**/
function forum_num_children($fid)
{
  $Forums = Array();
  $query = db_query("SELECT COUNT(ForumID) AS numchildren FROM F_Forums WHERE F_Forums.ParentForum=%d;", $fid);
  $Forums = uieforum_to_array($query);
  return $Forums[0]->numchildren;
}

/** Returns an array of all forums as objects.
**/
function get_all_forums()
{
   Global $user;
   $Forums = Array();

   $query = db_query("SELECT STRAIGHT_JOIN DISTINCT (F_Forums.ForumID), F_Forums.* FROM F_Forums ORDER BY ForumName ASC");
   $Forums = uieforum_to_array($query);
   return $Forums;
}

/** Returns a forum object that corresponds to a given forum fid
**/
function get_forum($fid, $list_only = false)
{
  static $forumList = array();

  if(!$forumList[$fid])
  {
    $limitsql = "SELECT * FROM F_Forums WHERE ForumID=%d";
    $query = db_query($limitsql, $fid);
    if ($Error = mysql_error())
      echo "$Error";
    $forumList[$fid] = mysql_fetch_object($query);
  }
  return $forumList[$fid];
}

/**  Returns a 2D array containing a forum object, and it's indentation int.
     Forums are listed in order of inheritance, weight, and then name.
     eg:
root
-- 1
---- 1a
-- 2
---- 2a
------ 2aa
**/
function get_forums_indented($Forum = null, $indent = 0, $stop_recursion_on_forumid = false, $mod_only = false)
{
  static $found_vals = array();

  $big_array = array();
  if(is_int($Forum)) $Forum = get_forum($Forum, true);
  $ForumList = get_forums($Forum->ForumID);

  if($Forum != null)
  {
    if(!$mod_only || ($mod_only && user_access('moderate '.uieforum_get_module_security_name().'_'.$Forum->ForumID.'_'.uieforum_get_module_security_name())))
    {
      $big_array[] = array($Forum, $indent);
      $found_vals[] = $Forum->ForumID;
    }
  }
  if (sizeof($ForumList) >= 0)
  {
    $indent++;
    foreach($ForumList AS $fo)
    {
      if($fo->ForumID != $stop_recursion_on_forumid)
      {
        $temp_fo = get_forums_indented($fo, $indent, $stop_recursion_on_forumid, $mod_only);

        if(forum_num_children($fo->ForumID) > 0)
        {
          foreach($temp_fo AS $t)
          {
            $big_array[] = $t;
          }
        }
        elseif(!$mod_only || ($mod_only && user_access('moderate '.uieforum_get_module_security_name().'_'.$fo->ForumID.'_'.uieforum_get_module_security_name())))
          $big_array[] = array($fo, $indent);
      }
    }
  }
  return $big_array;
}

/** Returns the list of security groups when fid is false (or null)
    otherwise, it returns the list of security restrictions currently set on a given forum
**/
function get_security_groups($fid = false, $arr = false)
{
   static $generic;
   if(isset($generic)) return $generic;
   $groups = Array();

   if(!$fid)
     $query = db_query("SELECT * FROM F_Groups ORDER BY GroupID ASC");
   else
   {
     $limitsql = "SELECT g.*, ga.ForumID AS HasAccess FROM F_Groups g, F_Groups_Access ga WHERE (ga.ForumID=%d";
     if($arr && sizeof($arr) > 0)
     {
       foreach($arr AS $a)
         $limitsql .= " OR ga.ForumID=".$a;
     }
     $limitsql .= ") AND g.GroupID = ga.GroupID";
     $query = db_query($limitsql, $fid);
   }

   $groups = uieforum_to_array($query);
   if($arr) $generic = $groups;

   return $groups;
}

/** Returns the security group that corresponds to a given groupid
**/
function get_security_group($GroupID)
{
   $query = db_query("SELECT * FROM F_Groups WHERE GroupID=%d", $GroupID);
   return mysql_fetch_object($query);
}

/** Adds a new security group.
    Param: $GroupName - the name of the group to add
    Param: $GroupShortName - the shortname of the group to add
**/
function add_security_group($GroupName, $GroupShortName)
{
   $query = db_query("INSERT INTO F_Groups (GroupName, GroupShortName) VALUES ('%s', '%s')", $GroupName, $GroupShortName);
   if ($Error = mysql_error())
     return "$Error";
}

/** Edits an existing security group.
    Param: $GroupID - the id of the group to modify
    Param: $GroupName - the name of the group to modify
    Param: $GroupShortName - the shortname of the group to modify
**/
function edit_security_group($GroupID, $GroupName, $GroupShortName)
{
   $query = db_query("UPDATE F_Groups SET GroupName='%s', GroupShortName='%s' WHERE GroupID=%d", $GroupName, $GroupShortName, $GroupID);
   if ($Error = mysql_error())
     return "$Error";
}

/** Deletes a thread, and all posts contained therein
**/
function delete_security_group($GroupID)
{
  $query = db_query("DELETE FROM F_Groups WHERE GroupID=%d", $GroupID);
  if ($Error = mysql_error())
    return "$q - $Error";

  $query = db_query("DELETE FROM F_Groups_Access WHERE GroupID=%d", $GroupID);
  if ($Error = mysql_error())
    return "$q - $Error";
}

/** Returns the number of posts by a user
**/
function get_user_post_page_count($uid)
{
   return uieforum_get_page_count("SELECT COUNT(PostID) AS numrows FROM F_Posts, users WHERE users.uid=%d AND F_Posts.Poster = users.uid", $uid);
}

/** Returns the number of threads by a user
**/
function get_user_thread_page_count($uid)
{
   return uieforum_get_page_count("SELECT COUNT(ThreadID) AS numrows FROM F_Threads, users WHERE users.uid=%d AND F_Threads.Creator = users.uid", $uid);
}

/** Returns the number of rows in a query
**/
function uieforum_get_page_count($str, $id)
{
  $query = db_query($str, $id);
  if($query == null)
  {
    return 1;
  }
  else
    return uieforum_get_row_count($query);
}

/** Returns the last post time for a user
**/
function get_last_post_time_for_user($uid)
{
   $query = db_query("SELECT F_Posts.Posted FROM users, F_Posts WHERE F_Posts.Poster=%d ORDER BY F_Posts.PostID DESC LIMIT 1", $uid);
   $obj = mysql_fetch_object($query);
   return $obj->Posted;
}

/**
**/
function get_last_forum_post_test($fid)
{
  return mysql_fetch_object(db_query("SELECT users.uid, users.name, F_Threads.ThreadID, MAX(LastPost) AS LastPost FROM F_Threads, F_Forums, users WHERE F_Forums.ForumID=%d AND F_Forums.ForumID=F_Threads.ForumID AND users.uid=F_Threads.LastPoster GROUP BY F_Threads.ThreadID ORDER BY LastPost DESC LIMIT 1", $fid));
}

/** Gets the last post in a forum
**/
function get_last_forum_post($Forum)
{
  $ForumList = get_forums($Forum->ForumID);
  $obj = get_last_forum_post_test($Forum->ForumID);

  $latestpost = $obj->LastPost;
  $forumToReturn = $obj;

  if (sizeof($ForumList) != 0)
  {
    foreach($ForumList AS $fo)
    {
      $PostThingObject = get_last_forum_post_test($fo->ForumID);
      $PostThing = $PostThingObject->LastPost;
      if ($PostThing > $latestpost)
      {
        $latestpost = $PostThing;
        $forumToReturn = $PostThingObject;
      }
    }
  }
  return $forumToReturn;
}

/** Returns the number of rows in a query
**/
function uieforum_get_row_count($var)
{
  $rows = 0;
  if ($row = mysql_fetch_array($var, MYSQL_ASSOC))
    $rows = $row['numrows'];
  return $rows;  
}

/** Returns how many pages we have when using paging
**/
function uieforum_get_max_page_count($numrows)
{
  return ceil($numrows/variable_get('forum_per_page', 25));
}

function uieforum_get_current_page_link($includepage = false)
{
  static $self = "";
  if(!$self)
  {
    if (uie_id('c'))
    {
      $self .= "&c=".uie_id('c');
      if (uie_id('ThreadID'))
      {
        $self .= "&ThreadID=".uie_id('ThreadID');
      }
    }
    else
    {
      if (uie_id('fid'))
      {
        $self .= "&fid=".uie_id('fid');
      }
    }
  }

  if($includepage && uie_id('page'))
  {
    return $self . "&page=".uie_id('page');
  }
  else
  {
    return $self;
  }
}

/** Returns a string containing page numbers for the current $page and $maxPage
**/
function uieforum_get_page_numbers($numrows)
{
  $page = uie_id("page");

  $self = uieforum_get_current_page_link();

// print 'previous' link only if we're not on page one
  if ($page > 1)
  {
    $prevPageNumber = $page - 1;
    $prev = " ".l(t('&lt;'), uieforum_get_module_menu_name(), null, $self . "&page=".$prevPageNumber, null, null, true);
    $first = " ".l(t('<strong>&laquo;</strong>'), uieforum_get_module_menu_name(), null, $self, null, null, true);
  }
  else
  {
    $prev  = ' &lt; ';       // we're on page one, don't enable 'previous' link
    $first = ' <strong>&laquo;</strong> '; // nor 'first page' link
  }

// print 'next' link only if we're not on the last page
  $maxPage = uieforum_get_max_page_count($numrows);
  if ($page < $maxPage)
  {
    $nextPageNumber = $page + 1;
    $next = " ".l(t('&gt;'), uieforum_get_module_menu_name(), null, $self . "&page=".$nextPageNumber, null, null, true);
    $last = " ".l(t('<strong>&raquo;</strong>'), uieforum_get_module_menu_name(), null, $self . "&page=".$maxPage, null, null, true);
  }
  else
  {
    $next = ' &gt; ';      // we're on the last page, don't enable 'next' link
    $last = ' <strong>&raquo;</strong> '; // nor 'last page' link
  }

  $table = "Page: ";
  $table .= $first . $prev . " <strong>$page</strong> of <strong>$maxPage</strong>" . $next . $last;
  return $table;
}

/** Creates an array of mysql objects
**/
function uieforum_to_array($val, $key = false)
{
  $array = array();
  if (mysql_num_rows($val) > 0)
  {
    while ( $Result = mysql_fetch_object($val) )
    {
      $resArray = (array)($Result);
      if($key)
      {
        $array[$resArray[$key]] = $Result;
      }
      else
      {
        $array[] = $Result;
      }
    } # Loop until we have them all
  }
  return $array;
}

/** Returns an array of the last posts made on the forum module. This _IS_ secured using get_allowed_forums()
**/
function uieforum_get_last_posts($num_posts = 10, $fid=false)
{
   global $user;

  $Threads = Array();
  $limitsql = "SELECT DISTINCT (F_Forums.ForumID), F_Threads.*, F_Forums.ForumName FROM F_Forums, F_Threads, F_Posts WHERE";

  if($fid)
    $limitsql .= " F_Forums.ForumID=%d AND ";

  $limitsql .= " F_Posts.ThreadID=F_Threads.ThreadID AND F_Forums.ForumID=F_Threads.ForumID".get_allowed_forums();
  $limitsql .= " ORDER BY LastPost DESC LIMIT ".$num_posts;
  if($fid)
    $query = db_query($limitsql, $fid);
  else
    $query = db_query($limitsql);
  echo mysql_error();

  $Threads = uieforum_to_array($query);
  return $Threads;
}

/** Returns a post object that corresponds to a given PostID
**/
function uieforum_get_post($PostID)
{
  $query = db_query("SELECT STRAIGHT_JOIN * FROM F_Posts,users WHERE PostID=%d and F_Posts.Poster = users.uid", $PostID);
  if ($Error = mysql_error())
    echo "$Error";
  return mysql_fetch_object($query);
}

/** Returns an array of posts that are contained with a given thread
**/
function uieforum_get_posts($ThreadID, $paged = true)
{
  static $storageArray = array();

  if(!$storageArray[$ThreadID])
  {
    $Posts = Array();
    $q = "SELECT * FROM F_Posts LEFT JOIN users ON F_Posts.Poster = users.uid WHERE ThreadID=%d ORDER BY PostID ASC";
    if($paged)
      $q .= " LIMIT ".uieforum_get_pages_offest().", ".variable_get('forum_per_page', 25);

    $query = db_query($q, $ThreadID);
    if ($Error = mysql_error())
      echo "$Error";
    $Posts = uieforum_to_array($query);
    $storageArray[$ThreadID] = $Posts;
  }
  return $storageArray[$ThreadID];
}

/** Creates a thread
    Param: ThreadTitle - Title of the thread
    Param: ThreadText - Text(content) for the thread
    Param: fid - The forum to add this thread to
**/
function uieforum_create_thread($ThreadTitle, $ThreadText, $fid)
{
  Global $user;
  $now = uieforum_get_now();

  $query = db_query("INSERT INTO F_Threads (ThreadID, ThreadTitle, Creator, Created, LastPoster, LastPost, Locked, Sticky, ForumID) VALUES (NULL,'%s','%d','%s','%d','%s', '%s', '%s', %d)", $ThreadTitle, $user->uid, $now, $user->uid, $now, '0', '0', $fid);
  if ($Error = mysql_error())
  {
    echo $Error;
    return false;
  }
  $query = db_query("SELECT LAST_INSERT_ID() AS id");
  if ($Error = mysql_error())
  {
    echo "$Error";
    return false;
  }
  $result = mysql_fetch_object($query);
  if (!uieforum_add_post($result->id, $ThreadTitle, $ThreadText))
  {
    echo "<font color=\"red\">awh pooey :(</font><br />";
    return false;
  }
  uieforum_update_counts($fid, "forum", "thread", true);

  return $result->id;
}

/** Splits a thread from a given post onwards (inclusive)
    Param: edit - the array containing all relevant details needed for splitting
**/
function uieforum_split_thread($edit)
{
  $tid = $edit['tid'];
  $pid = $edit['pid'];
  $fid = $edit['fid'];
  $poster = $edit['poster'];
  $posted = $edit['posted'];
  $title = $edit['title']." [ Split ]";

  //Create the thread
  $query = db_query("INSERT INTO F_Threads (ThreadID, ThreadTitle, Creator, Created, LastPoster, LastPost, Locked, Sticky, ForumID) VALUES (NULL,'%s','%d','%s','%d','%s', '%s', '%s', '%d')", $title, $poster, $posted, $poster, $posted, '0', '0', $fid);
  if ($Error = mysql_error())
  {
    echo $Error;
    return false;
  }
  $query = db_query("SELECT LAST_INSERT_ID() AS id");
  if ($Error = mysql_error())
  {
    echo "$Error";
    return false;
  }
  $result = mysql_fetch_object($query);

  $newThreadID = $result->id;

  $query = db_query("UPDATE F_Posts SET ThreadID='%d' WHERE ThreadID='%d' AND PostID >= '%d'", $newThreadID, $tid, $pid);
  if ($Error = mysql_error())
  {
    echo "$Error";
    return false;
  }

  uieforum_update_counts($tid, "thread");
  uieforum_update_counts($newThreadID, "thread");
  uieforum_update_counts($fid, "forum", "thread", true);

  if(uieforum_update_last_post_details($newThreadID) && uieforum_update_last_post_details($tid))
    return $tid;
  else
    return false;
}

function uieforum_update_last_post_details($ThreadID)
{
  //Update the last-post of a thread
  $query = db_query("SELECT * FROM F_Posts WHERE ThreadID='%d' ORDER BY PostID DESC LIMIT 1", $ThreadID);
  if ($Error = mysql_error())
  {
    echo "$Error";
    return false;
  }
  $result = mysql_fetch_object($query);
  $query = db_query("UPDATE F_Threads SET LastPost='%s', LastPoster='%d' WHERE ThreadID='%d'", $result->Posted, $result->Poster, $ThreadID);
  if ($Error = mysql_error())
  {
    echo "$Error";
    return false;
  }
  return true;
}

/** Merges 2 threads
    Param: from - the thread to merge into the parent
	Param: to - the parent
**/
function uieforum_merge_thread($from, $to)
{
  $threadFrom = get_thread($from);

  $query = db_query("UPDATE F_Posts SET ThreadID='%d' WHERE ThreadID='%d'", $to, $from);
  if ($Error = mysql_error())
  {
    echo "$Error";
    return false;
  }

  $query = db_query("DELETE FROM F_Threads WHERE ThreadID='%d'", $from);
  if ($Error = mysql_error())
  {
    echo "$Error";
    return false;
  }

  uieforum_update_counts($to, "thread");
  uieforum_update_counts($to, "thread", "view", $threadFrom->ViewCount);
  uieforum_update_counts($threadFrom->ForumID, "forum", "thread", -1);

  if(uieforum_update_last_post_details($to))
    return $to;
  else
    return false;
}

/** Adds a new post
    Param: ThreadID - Thread to add the new post to
    Param: Title - Title of the post (optional)
    Param: Text - Content of the post
**/
function uieforum_add_post($ThreadID, $Title, $Text)
{
  Global $user;
  $Thread = get_thread($ThreadID);
  $now = uieforum_get_now();

  $query = db_query("INSERT INTO F_Posts (PostID, PostTitle, ThreadID, Poster, Posted, Content) VALUES (NULL,'%s','%d','%d','%s','%s')", $Title, $ThreadID, $user->uid, $now, $Text);
  $Error = mysql_error();
  $query = db_query("SELECT LAST_INSERT_ID() AS id");
  if ($Error || $Error2 = mysql_error())
  {
    form_set_error('UIE_FORUM_FORM', t($Error?$Error:$Error2));
    return false;
  }
  $result = mysql_fetch_object($query);
  $ThisPostID = $result->id;

  $query = db_query("UPDATE F_Threads SET LastPoster='%d', LastPost='%s' WHERE ThreadID=%d", $user->uid, $now, $ThreadID);
  if ($Error = mysql_error())
  {
    form_set_error('UIE_FORUM_FORM', t($Error));
    return false;
  }

  uieforum_update_counts($Thread->ThreadID, "thread", "post", true);
  uieforum_update_counts($Thread->ForumID, "forum", "post", true);

  return $ThisPostID;
}

/** Adds a new Forum
    Param: ForumName - Name of the forum to add
    Param: ForumDesc - Description of the forum to add
    Param: ForumParent - Parent forum of the forum to add
**/
function uieforum_add_forum($ForumName,$ForumDesc,$ForumParent)
{
  $query = db_query("INSERT INTO F_Forums (ForumName, ParentForum, ForumDesc) VALUES ('%s', %d, '%s')", $ForumName, $ForumParent, $ForumDesc);
  if ($Error = mysql_error())
  {
    echo "$Error";
    return false;
  }

  $query = db_query("SELECT LAST_INSERT_ID() AS id");
  if ($Error = mysql_error())
  {
    return "Unable to add new forum";
  }

  $obj = mysql_fetch_object($query);
  if(variable_get('uieforum_auto_greet', 1))
    uieforum_create_thread("Welcome to ".$ForumName, "This is the first thread in your new forum. You can disable this auto-greeting post by disabling the relevant option on the configure page.", $obj->id);
}

/** Deletes a post
**/
function uieforum_delete_post($PostID)
{
  $Post = uieforum_get_post($PostID);
  // Delete the post
  $query = db_query("DELETE FROM F_Posts WHERE PostID=%d", $PostID);
  if ($Error = mysql_error())
    return "$Error";

  // Check if the thread that the post came from is empty.
  $Posts = uieforum_get_posts($Post->ThreadID, false);
  $count = count($Posts);
  if ($count <= 0)
  {
    //Delete thread as no more posts exist
    $test = false;
    $test = uieforum_delete_thread($Post->ThreadID);
    if($test)
      return $test;
  }
  else
  {
    //Update thread as the post that was deleted was the last one. The "lastposter" and "lastpost" database entries need to be updated
    $Post = $Posts[$count-1];
    $Thread = get_thread($Post->ThreadID);
    $query = db_query("UPDATE F_Threads SET LastPoster='%d', LastPost='%s' WHERE ThreadID='%d'", $Post->Poster, $Post->Posted, $Post->ThreadID);

    uieforum_update_counts($Post->ThreadID, "thread", "post", -1);
    uieforum_update_counts($Thread->ForumID, "forum", "post", -1);
    if ($Error = mysql_error())
      return "$Error";
  }
}

/** Moves a post from one thread to another
**/
function uieforum_move_post($PostID, $ThreadID)
{
  $Post = uieforum_get_post($PostID);
  $query = db_query("UPDATE F_Posts SET ThreadID=%d WHERE PostID=%d", $ThreadID, $PostID);

  if ($Error = mysql_error())
    return "$Error";

  uieforum_update_last_post_details($ThreadID);
  uieforum_update_last_post_details($Post->ThreadID);

  uieforum_update_counts($Post->ThreadID, "thread", "post", -1);
  uieforum_update_counts($ThreadID, "thread", "post", true);
  return $ThreadID;
}

/** Deletes a thread, and all posts contained therein
**/
function uieforum_delete_thread($ThreadID, $useTotalCounts = false)
{
  $Thread = get_thread($ThreadID);

  $query = db_query("DELETE FROM F_Posts WHERE ThreadID=%d", $ThreadID);
  if ($Error = mysql_error())
    return "$q - $Error";

  $query = db_query("DELETE FROM F_Threads WHERE ThreadID=%d", $ThreadID);
  if ($Error = mysql_error())
    return "$Error";

  uieforum_update_counts($Thread->ForumID, "forum", ($useTotalCounts ? "totalthread" : "thread"), -1);
  uieforum_update_counts($Thread->ForumID, "forum", ($useTotalCounts ? "totalpost" : "post"), ($Thread->PostCount)*-1);
}

/** Deletes a forum, and all forums, threads and posts contained therein
**/
function uieforum_delete_forum($ForumID)
{
  $ThisForum = get_forum($ForumID);
  $ThisChildren = get_forums($ForumID);
  $tester = false;

  if(sizeof($ThisChildren) > 0)
  {
    foreach($ThisChildren AS $child)
    {
      if($tester = uieforum_delete_forum($child->ForumID))
        return $tester;
    }
  }
  $ThisThreads = get_threads_from_forum($ForumID);

  if(sizeof($ThisThreads) > 0)
  {
    foreach($ThisThreads AS $tt)
    {
      if($tester = uieforum_delete_thread($tt->ThreadID, true))
        return $tester;
    }
  }

  $query = db_query("DELETE FROM F_Groups_Access WHERE ForumID=%d", $ForumID);
  if ($Error = mysql_error())
    return "$Error";

  if($ThisForum->ParentForum)
  {
    uieforum_update_counts($ThisForum->ParentForum, "forum", "totalpost", ($ThisForum->PostCount)*-1);
    uieforum_update_counts($ThisForum->ParentForum, "forum", "totalthread", ($ThisForum->ThreadCount)*-1);
  }

  $query = db_query("DELETE FROM F_Forums WHERE ForumID=%d", $ForumID);
  if ($Error = mysql_error())
    return "$Error";

  if($tester)
    return $tester;
}

/** Edits a thread
    Param: ThreadID - ID of thread to edit
    Param: ThreadTitle - Titleof thread to edit
    Param: Locked - Is Thread locked?
    Param: Sticky - Is Thread stickied?
    Param: ForumID - ForumID of thread to edit
**/
function uieforum_edit_thread($ThreadID, $ThreadTitle, $Locked, $Sticky, $ForumID)
{
  $Thread = get_thread($ThreadID);

  $q = "UPDATE F_Threads SET ThreadTitle='%s', Locked='%d',Sticky='%d' ";
  if($ForumID)
    $q .= ",ForumID='%d' ";
  $q .= "WHERE ThreadID='%d'";

  if($ForumID)
    $query = db_query($q, $ThreadTitle, $Locked, $Sticky, $ForumID, $ThreadID);
  else
    $query = db_query($q, $ThreadTitle, $Locked, $Sticky, $ThreadID);

  if($Thread->ForumID != $ForumID)
  {
    uieforum_update_counts($Thread->ForumID, "forum", "post", ($Thread->PostCount)*-1);
    uieforum_update_counts($Thread->ForumID, "forum", "thread", -1);
    uieforum_update_counts($ForumID, "forum", "post", $Thread->PostCount);
    uieforum_update_counts($ForumID, "forum", "thread", true);
  }

  if ($Error = mysql_error())
    return "$Error";
}

/** Edits a forum
**/
function uieforum_edit_forum($fid,$ForumName,$ForumDesc,$ForumParent=false, $weight = 0, $accessgroups, $Locked)
{
  $query = db_query("SELECT ForumID FROM F_Forums WHERE ForumID=%d", $fid);
  if ($query == NULL)
    return "No such forum exists.";

  $q="UPDATE F_Forums SET ForumName='%s', ForumDesc='%s', weight='%d', Locked='%d' ";
  if($ForumParent)
    $q .= ",ParentForum='%d' ";
  $q .= "WHERE ForumID='%d'";

  if($ForumParent)
    $query = db_query($q, $ForumName, $ForumDesc, $weight, $Locked, $ForumParent, $fid);
  else
    $query = db_query($q, $ForumName, $ForumDesc, $weight, $Locked, $fid);
  if ($Error = mysql_error())
    return "$Error";

  $query = db_query("DELETE FROM F_Groups_Access WHERE ForumID=%d", $fid);
  if ($Error = mysql_error())
    return "$Error";

  foreach($accessgroups AS $ag)
  {
    if(is_array($ag)) continue;
    $query = db_query("REPLACE INTO F_Groups_Access SET ForumID='%d', GroupID='%d'", $fid, $ag);
    if ($Error = mysql_error())
      return "$Error";
  }
}

/** Edits a post
**/
function uieforum_edit_post($PostID, $Title, $Text, $editor, $reason)
{
  Global $user;
  $now = uieforum_get_now();
  $query = db_query("UPDATE F_Posts SET PostTitle='%s', Content='%s', Edit='%s', Editor='%d', EditReason='%s' WHERE PostID=%d", $Title, $Text, $now, $editor, $reason, $PostID);
  if ($Error = mysql_error())
    return "$Error";
}

/** Returns the postcount of a user
**/
function uieforum_post_count($UserID)
{
  global $user;
  if (!isset($user->uid)) { return NULL; }

  $query = db_query("SELECT COUNT(PostID) from F_Posts WHERE Poster=%d", $UserID);
  return mysql_result($query, 0);
}

/** Displays a post on screen
**/
function uieforum_display_post($PostTime=0, $ThreadID, $PostID, $uid, $PostTitle, $PostText, $postcount = -1, $IsPreview = false, $fid, $editedpost = false, $sig = false, $show_avatar = true, $show_online_status = true, $show_post_count = true, $show_ranks = true, $show_regd = true, $show_sigs = true)
{
  Global $user;
  $guest_user = (!isset($uid) || $uid == 0 ? true : false);

  if($PostTime == 0)
    $PostTime = uieforum_get_now(0);

  $post_header = array(
    array('data' => '', 'colspan' => '1', 'class' => 'created', 'style' => 'font-weight: bold'),
    array('data' => '', 'colspan' => '1', 'class' => 'forum_pagenums')
  );
  $post_content = array(
    array('data' => '', 'colspan' => '1', 'class' => 'post_user_info', 'style' => 'font-weight: bold'),
    array('data' => '', 'colspan' => '1', 'class' => 'post_text')//, 'style' => 'vertical-align: top')
  );

  if ($IsPreview)
  {
    $post_header = array($post_header[0]);
    $post_content = array($post_content[1]);
    $post_footer = array($post_header[0]);
    $post_header [0]['colspan'] = '2';
    $post_header [0]['data'] = uieforum_filter('process', null, null, $PostTitle, true);
    $post_content[0]['data'] .= uieforum_filter('process', null, null, $PostText, true);
    $post_content[0]['colspan'] = 2;
  }
  else
  {
    $post_footer = array(
      array('data' => '', 'colspan' => '1', 'class' => 'created', 'style' => 'font-weight: bold'),
      array('data' => '', 'colspan' => '1', 'class' => 'forum_pagenums')
    );

    $post_header [0]['data'] = $PostTime;
    $Poster = get_user_from_id($uid);


    $post_header [1]['data'] .= l($PostID, uieforum_get_module_menu_name(), array('name' => $PostID), uieforum_get_current_page_link(true).'#'.$PostID);

    if ($postcount == 0) $post_header[1]['data'] .= l(null, null, array('name' => 'lastpost'));

    if(user_access('administer '.uieforum_get_module_security_name()) || user_access('moderate '.uieforum_get_module_security_name().'_'.$fid.'_'.uieforum_get_module_security_name()))
    {
      $dropdownmenu = array(
        null => t($PostID),
        t(url('admin/'.uieforum_get_module_menu_name().'/edit/post/'.$PostID)) => t('Delete Post'),
        t(url('admin/'.uieforum_get_module_menu_name().'/edit/post/move/'.$PostID)) => t('Move Post'),
        t(url('admin/'.uieforum_get_module_menu_name().'/split/thread/'.$PostID)) => t('Split Thread'),
        t(url('admin/'.uieforum_get_module_menu_name().'/merge/thread/'.$ThreadID)) => t('Merge Thread')
/*
        t(url('/admin/'.uieforum_get_module_menu_name().'/post/edit/'.$PostID)) => t('Delete Post'),
        t(url('/admin/'.uieforum_get_module_menu_name().'/post/move/'.$PostID)) => t('Move Post'),
        t(url('/admin/'.uieforum_get_module_menu_name().'/thread/split/'.$PostID)) => t('Split Thread'),
        t(url('/admin/'.uieforum_get_module_menu_name().'/thread/merge/'.$ThreadID)) => t('Merge Thread')
*/
      );

      $forum_TempForm = null;
      $forum_TempForm["admin_edit_$PostID"] = array(
        '#type' => 'select',
        '#title' => null,
        '#default_value' => t($PostID),
        '#options' => $dropdownmenu,
        '#description' => null,
        '#attributes' => array('onChange' => "forum_admin_edit($PostID)")
      );

      $forum_TempForm['#method'] = 'post';
      $forum_TempForm['#action'] = null;
      $forum_TempForm['#attributes'] = array('name' => 'unreal_'.$PostID);
      $post_header [1]['data'] .= drupal_get_form("admin_edit_$PostID", $forum_TempForm);
    }





    $UserName = $Poster->name;
    $post_content[0]['data'] .= theme('username', user_load(array('uid' => $uid)))."<br /><small>\n";
    if(!$guest_user)
    {
      if($show_ranks)
      {
	      if($Poster->uid == 1)
          $userrank = 'Super Admin';
	      else
          $userrank = uieforum_user_rank(uieforum_uie_storage('postcount', $Poster->uid));
        if($userrank != null)
          $post_content[0]['data'] .= "$userrank<br /><br />\n";
      }
      if($show_avatar) $post_content[0]['data'] .= theme_user_picture($Poster);
      if($show_regd) $post_content[0]['data'] .= "<br />Joined: ".uieforum_parse_date_only($Poster->created);

      if($show_post_count)
      {
        $userpostcount = uieforum_uie_storage('postcount', $Poster->uid);
        if($userpostcount != null)
          $post_content[0]['data'] .= "<br/>Posts: $userpostcount<br /><br />";
      }
      if($show_online_status)
      {
        $is_active = uieforum_uie_storage('useronline', $Poster->uid);
        $post_footer[0]['data'] .= _uieforum_user_online($Poster->name, $is_active);
      }
      if($user->uid || variable_get('forum_report_post_guest_allow', 0))
      {
        $alt = 'Report post to an Admin/Moderator';
        $file = variable_get('forum_icon_path', 'modules/'.uieforum_get_module_name().'/uie')."/forum-report.gif";
        $reportPostImage = theme('image', $file, $alt, $alt, '', false);

        if($reportPostImage)
        {
          $reportPost .= l($reportPostImage, uieforum_get_module_menu_name(), null, "c=reportpost&PostID=$PostID", null, null, true);
          $post_footer[0]['data'] .= $reportPost;
        }
      }
    }
    $post_content[0]['data'] .= "</small>\n";




    if (strlen($PostTitle) > 0)
      $post_content[1]['data'] .= "<strong>".uieforum_filter('process', null, null, $PostTitle, true)."</strong><br/>";
    $post_content[1]['data'] .= uieforum_filter('process', null, null, $PostText, true);
    $post_content[1]['data'] .= "<br/><br/>";
    if(!$guest_user && ($show_sigs && $sig))
      $post_content[1]['data'] .= "<div class=\"signature\">__________________<br/>".uieforum_filter('process', null, null, $sig)."</div>";



    $INTERACTION_TEXT = false;
    if (user_access('post new threads/posts'))
    {
      if(user_access('administer '.uieforum_get_module_security_name()) || user_access('moderate '.uieforum_get_module_security_name().'_'.$fid.'_'.uieforum_get_module_security_name()) || $user->uid == $uid)
        $INTERACTION_TEXT = l(t('Edit'), uieforum_get_module_menu_name(), null, "c=editpost&PostID=$PostID"). " - ";
      $INTERACTION_TEXT .= l(t('Quote'), uieforum_get_module_menu_name(), null, "c=newpost&ThreadID=$ThreadID&QuoteID=$PostID");
    }
    if($INTERACTION_TEXT) $post_footer[1]['data'] .= $INTERACTION_TEXT;

    if(is_array($editedpost) && $editedpost[0])
    {
      $tempuser = get_user_from_id($editedpost[0]);
      $DEFAULT_EDIT_REASON = trim(uieforum_filter('process', null, null, variable_get('forum_default_edit_reason', ''), true));
      $outputtext = "Last edited by ".$tempuser->name." (".uieforum_parse_date($editedpost[1]).")";

      $edited_reason = uieforum_filter('process', null, null, $editedpost[2], true);
      if(strlen(trim($edited_reason)) <= 0) $edited_reason = $DEFAULT_EDIT_REASON;
      if(strlen($edited_reason) > 0)
        $outputtext .= " Reason: ".$edited_reason;
      $post_content[1]['data'] .= "<hr><div class='uie_edit_text'><em>".$outputtext."</em></div>";
    }
  }
  return array($post_header, $post_content, $post_footer);
}

/** Returns the current date/time
**/
function uieforum_get_now($days=0)
{
  $Now = time();
  $Time = $Now - (86400*$days); # 86400 = num seconds in a day.
  return gmdate("Y-m-d H:i:s",$Time);
}

/** Not used at the moment - returns a different date format for rss display
**/
function uieforum_parse_date_rss($d)
{
  return date("D, d M Y H:i", strtotime($d))." +0000";
}

/**Returns a formatted date/time
**/
function uieforum_parse_date($d, $format = "d M Y - H:i")
{
  return date($format, strtotime($d));
}

/** Returns a formatted date
**/
function uieforum_parse_date_only($d)
{
  return date("d M Y", $d);
}

/** Checks to see if a user has posted too soon since their last post.
**/
function uieforum_posted_too_soon($timeout)
{
  Global $user;
  $time = time();

  $userslastpost = get_last_post_time_for_user($user->uid);

  $ender = $time - strtotime($userslastpost);
  if($ender <= $timeout)
    return $ender;
  else
    return false;
}

/** Returns a smiley array
**/
function uieforum_get_smiley_list()
{
  static $smilies_array = array();

  if(sizeof($smilies_array) == 0)
  {
    /** Array of smilies
      contents: text replace   ---   regex to use to replace   ---   what to replace text with
      eg: ':)', ':) regex', 'smile.gif'
    **/
    $smilies_array = array
    (
      array(':idea:', 	'/:(?i)idea:/' ,	_uieforum_icon(null, null, null, 'idea.gif', true)),
      array(':mad:', 	'/:(?i)mad:/'  ,	_uieforum_icon(null, null, null, 'mad.gif', true)),
      array(':huh:', 	'/:(?i)huh:/'  ,	_uieforum_icon(null, null, null, 'confused.gif', true)),
      array(':lol:', 	'/:(?i)lol:/'  ,	_uieforum_icon(null, null, null, 'lol.gif', true)),
      array(':))'  , 	'/:-?\)\)/'    ,	_uieforum_icon(null, null, null, 'lol.gif', true)),
      array(':)'   , 	'/:-?\)/'      ,	_uieforum_icon(null, null, null, 'smile.gif', true)),
      array(':D'   , 	'/:-?[dD]/'    ,	_uieforum_icon(null, null, null, 'biggrin.gif', true)),
      array(':p'   , 	'/:-?[pP]/'    ,	_uieforum_icon(null, null, null, 'tongue.gif', true)),
      array(':('   , 	'/:-?\(/'      ,	_uieforum_icon(null, null, null, 'sad.gif', true)),
      array(':cool:',	'/:(?i)cool:/' ,	_uieforum_icon(null, null, null, 'cool.gif', true)),
      array(':crazy:',	'/:(?i)crazy:/',	_uieforum_icon(null, null, null, 'crazy.gif', true)),
      array(':fight:',	'/:(?i)fight:/',	_uieforum_icon(null, null, null, 'fight.gif', true)),
      array(':lurking:',	'/:(?i)lurking:/',	_uieforum_icon(null, null, null, 'lurking.gif', true)),
      array(':rolleyes:',	'/:(?i)rolleyes:/',	_uieforum_icon(null, null, null, 'rolleyes.gif', true)),
      array(':shock:',	'/:(?i)shock:/',	_uieforum_icon(null, null, null, 'shockcombo.gif', true)),
      array(':shoot:',	'/:(?i)shoot:/',	_uieforum_icon(null, null, null, 'shooting.gif', true)),
      array(':sleeping:',	'/:(?i)sleeping:/',	_uieforum_icon(null, null, null, 'sleeping.gif', true)),
      array(':|',    	'/:-?\|/'      ,	_uieforum_icon(null, null, null, 'stern.gif', true)),
      array(';)',    	'/;-?\)/'      ,	_uieforum_icon(null, null, null, 'wink.gif', true))
    );
  }
  return $smilies_array;
}

/** Order to display smilies in **/
function uieforum_get_smiley_samples()
{
  static $SmilieSamples = array();

  if(sizeof($SmilieSamples) == 0)
  {
    $SmilieSamples = array
    ( 0 => array ( 6, 1, 13, 11),
      1 => array ( 7, 2, 10, 14),
      2 => array ( 5, 3, 17, 12),
      3 => array ( 9, 8, 16, 15),
      4 => array (18)
    );
  }
  return $SmilieSamples;
}

/** Returns a formatting icon array
**/
function uieforum_get_formatting_icons()
{
  $uie_rows = array();
  $uie_rows[] = array(
    array('data' => '<a href=javascript:Process(\'bold\') title=\'Insert bold text\'>'._uieforum_icon(null, null, null, 'bold.gif', null, true).'</a>'),
    array('data' => '<a href=javascript:Process(\'italic\') title=\'Insert italic text\'>'._uieforum_icon(null, null, null, 'italic.gif', null, true).'</a>'),
    array('data' => '<a href=javascript:Process(\'underline\') title=\'Insert underlined text\'>'._uieforum_icon(null, null, null, 'underline.gif', null, true).'</a>'),
    array('data' => '<a href=javascript:Process(\'url\') title=\'Insert a url\'>'._uieforum_icon(null, null, null, 'url.gif', null, true).'</a>'),
    array('data' => '<a href=javascript:Process(\'image\') title=\'Insert an inline image\'>'._uieforum_icon(null, null, null, 'image.gif', null, true).'</a>'),
    array('data' => '<a href=javascript:Process(\'quote\') title=\'Insert quoted text\'>'._uieforum_icon(null, null, null, 'quote.gif', null, true).'</a>'),
    array('data' => '<a href=javascript:Process(\'code\') title=\'Insert pre-formatted code\'>'._uieforum_icon(null, null, null, 'code.gif', null, true).'</a>'),
    array('data' => '<a href=javascript:Process(\'rant\') title=\'Give out sh*t about something\'>'._uieforum_icon(null, null, null, 'rant.gif', null, true).'</a>'),
    array('data' => '<a href=javascript:Process(\'left\') title=\'Align paragraph to left\'>'._uieforum_icon(null, null, null, 'align_left.jpg', null, true).'</a>'),
    array('data' => '<a href=javascript:Process(\'center\') title=\'Align paragraph to center\'>'._uieforum_icon(null, null, null, 'align_center.gif', null, true).'</a>'),
    array('data' => '<a href=javascript:Process(\'right\') title=\'Align paragraph to right\'>'._uieforum_icon(null, null, null, 'align_right.jpg', null, true).'</a>')
  );
  return $uie_rows;
}

function uieforum_get_pages_offest()
{
  static $pagesoffset = 0;

  if(is_numeric($pagesoffset) && $pagesoffset <= 0)
    $pagesoffset = ((uie_id("page") > 0 ? uie_id("page") - 1 : 0) ) * variable_get('forum_per_page', 25);
  return $pagesoffset;
}

function uieforum_get_forum_list_header()
{
  static $forum_forum_list_header = array();

  if(sizeof($forum_forum_list_header) == 0)
  {
    $forum_forum_list_header = array(
      array('data' => '&nbsp;', 'class' => 'created', 'class' => 'uieforumicon uieforum_nopadding'),
      array('data' => '<strong>Forum</strong>', 'class' => 'created'),
      array('data' => '<strong>Topics</strong>', 'class' => 'numtopics'),
      array('data' => '<strong>Posts</strong>', 'class' => 'numposts'),
      array('data' => '<strong>Last Post</strong>', 'class' => 'uieforum-last-reply')
    );
  }
  return $forum_forum_list_header;
}

function uieforum_get_topic_list_header()
{
  static $forum_topic_list_header = array();

  if(sizeof($forum_topic_list_header) == 0)
  {
    $forum_topic_list_header = array(
      array('data' => '&nbsp;', 'class' => 'uieforumicon uieforum_nopadding'),
      array('data' => '<strong>Thread</strong>', 'class' => 'created'),
      array('data' => '<strong>Replies</strong>', 'class' => 'numposts'),
      array('data' => '<strong>Views</strong>', 'class' => 'numposts'),
      array('data' => '<strong>Last Post</strong>', 'class' => 'uieforum-last-reply')
    );
  }
  return $forum_topic_list_header;
}

/** Checks to see of a post is being edited
**/
function uieforum_is_edit_post()
{
  static $is_edit = false;

  if(!$is_edit)
    $is_edit = isset($edit['UIE_FORUM_EDIT_POST']) ? true : false;
  return $is_edit;
}


function uieforum_get_post_text($init = false)
{
  global $edit;
  static $PostText = false;

  if($init)
    $PostText = trim($init);
  elseif(isset($edit['PostText']))
    $PostText = trim($edit['PostText']);
  return $PostText;
}

function uieforum_get_post_title($init = false)
{
  global $edit;
  static $PostTitle = false;

  if($init)
    $PostTitle = trim($init);
  elseif(isset($edit['PostTitle']))
    $PostTitle = trim($edit['PostTitle']);
  return $PostTitle;
}

function uieforum_get_edit_reason()
{
  global $edit;
  static $EditReason = false;

  if(isset($edit['EditReason']))
    $EditReason = trim($edit['EditReason']);
  return $EditReason;
}

function uieforum_current_forum($fid = false, $force = false)
{
  static $CurrentForum = false;

  if($force || (!$CurrentForum && ($fid)))
  {
    if(!$fid && $CurrentForum) $fid = $CurrentForum->ForumID;
    $CurrentForum = get_forum($fid);
  }
  return $CurrentForum;
}

function uieforum_current_thread($id = false, $method='normal')
{
  static $CurrentThread = false;

  if($id)
  {
    switch($method)
    {
      case 'post': $CurrentThread = get_thread_from_post($id); break;
      case 'normal': $CurrentThread = get_thread($id); break;
    }
  }
  return $CurrentThread;
}

function uieforum_get_thread_post_count($threadid)
{
  $query = mysql_fetch_object(db_query("SELECT COUNT(DISTINCT(F_Posts.PostID)) AS PostCount FROM F_Posts WHERE F_Posts.ThreadID=%d", $threadid));
  return $query->PostCount;
}

/**  Returns the number of threads/posts in a forum
**/
function uieforum_get_forum_info($init = false, $checkThisParent = false, $withThisForum = false)
{
  static  $checked = array(),
          $storageArray = array(),
          $list = array(),
          $masterOrder = array(),
          $masterOrderManipulation = array();

  if($init)
  {
    $masterOrder = get_forums_indented();
    usort($masterOrder, 'uieforum_sort_forums_for_recounts');
    $masterOrderManipulation = $masterOrder;

    $list = get_forums(null, null, true, true);
  }
  if($checkThisParent)
  {
    foreach($masterOrderManipulation AS $key => $fn)
    {
      $fn = $fn[0];
      $key = $fn->ForumID;
      if($withThisForum)
      {
        $fn = $list[$withThisForum];
        $key = $withThisForum;
      }
      if($fn->ParentForum == $checkThisParent || $withThisForum)
      {
        $list[$checkThisParent]->TotalThreadCount += $fn->ThreadCount;
        $list[$checkThisParent]->TotalPostCount += $fn->PostCount;

        return $list[$checkThisParent]->ParentForum;
      }
    }
    return null;
    $key = $fn = null;
  }


  foreach($masterOrder AS $key => $fn)
  {
    $fn = $fn[0];
    $key = $fn->ForumID;
    if(!$checked[$key] )
    {
      $checked[$key] = 1;

      $key2 = $key;

      while( $key2 = uieforum_get_forum_info(null, $key2, $key) )
      {}
    }
  }

  return $list;
}

function uieforum_update_all_counts($type, $fid = false, $tid = false)
{
  if(user_access('administer '.uieforum_get_module_security_name()))
  {
    if($type == "forums")
    {
      $q = "UPDATE F_Forums SET ThreadCount=0, PostCount=0, TotalThreadCount=0, TotalPostCount=0";
      $query = db_query($q);
      $Forums = uieforum_get_forum_info(true);

      uieforum_update_counts($Forums, "forum");
    }
    elseif($type == "threads")
    {
      if($fid)
      {
        $Threads = get_threads_from_forum($fid, false, false);
      }
      elseif($tid)
      {
        $Threads = array();
        $Threads[] = get_thread($tid);
      }
      else
      {
        $Threads = get_threads();
      }

      foreach($Threads as $t)
      {
        uieforum_update_counts($t->ThreadID, "thread");
      }
    }
  }
  return;
}

function uieforum_update_counts($id, $type, $counttype = false, $increment = false, $currentForum = true)
{
  switch($type)
  {
    case 'forum':
      if($increment == 0)
      {
        //In this case, "id" is an array of all the forums in the system, with their counts pre-calculated
        foreach($id AS $f)
        {
          $q = "UPDATE F_Forums SET ThreadCount='%d', PostCount='%d', TotalThreadCount='%d', TotalPostCount='%d' WHERE ForumID=%d";
          $query = db_query($q, $f->ThreadCount, $f->PostCount, $f->TotalThreadCount, $f->TotalPostCount, $f->ForumID);
        }
        return;
      }
      elseif($counttype)
      {
        $f = get_forum($id);
        if($counttype == "thread" || $counttype == "totalthread")
        {
          $q = "UPDATE F_Forums SET TotalThreadCount='%d' WHERE ForumID=%d";
          $query = db_query($q, $f->TotalThreadCount + $increment, $id);

          if($currentForum && $counttype != "totalthread")
          {
            $q = "UPDATE F_Forums SET ThreadCount='%d' WHERE ForumID=%d";
            $query = db_query($q, $f->ThreadCount + $increment, $id);
          }
        }
        elseif($counttype == "post" || $counttype == "totalpost")
        {
          $q = "UPDATE F_Forums SET TotalPostCount='%d' WHERE ForumID=%d";
          $query = db_query($q, $f->TotalPostCount + $increment, $id);

          if($currentForum && $counttype != "totalpost")
          {
            $q = "UPDATE F_Forums SET PostCount='%d' WHERE ForumID=%d";
            $query = db_query($q, $f->PostCount + $increment, $id);
          }
        }
      }
      else
      {
        return false;
      }
      if($f->ParentForum)
      {
        uieforum_update_counts($f->ParentForum, $type, $counttype, $increment);
      }
      break;

    case 'thread':
      $t = get_thread($id);
      $field = "PostCount";

      if($increment == 0)
      {
        $info = uieforum_get_thread_post_count($id);
        if($info < 0)
        {
          $info = 0;
        }
      }
      elseif($counttype)
      {
        if($counttype == "post")
        {
          $info = $t->PostCount + $increment;
        }
        if($counttype == "view")
        {
          $field = "ViewCount";
          $info = $t->ViewCount + $increment;
        }
      }
      else
      {
        return false;
      }
      $q = "UPDATE F_Threads SET ".$field."='%d' WHERE ThreadID=%d";
      $query = db_query($q, $info, $id);
      break;

    default:
  }
  if ($Error = mysql_error())
  {
    echo $Error;
    return false;
  }
}


function uieforum_uie_storage($source, $uid, $reset = false)
{
  static $postcount_list = array();
  static $useronline_list = array();
  if($reset)
  {
    $postcount_list = array();
    $useronline_list = array();
  }
  else
  {
    switch($source)
    {
      case 'postcount':
        if(!isset($postcount_list["'".$uid."'"]))
          $postcount_list["'".$uid."'"] = uieforum_post_count($uid);
	if($uid == 75) return $postcount_list["'".$uid."'"] - 549 - 999;
        return $postcount_list["'".$uid."'"];

      case 'useronline':
        if(!isset($useronline_list["'".$uid."'"]))
        {
          // Count users with activity in the past defined period.
          $time_period = variable_get('user_block_seconds_online', 2700);
          $calc = time() - $time_period;

          // Perform database queries to gather online user lists (used to see if the poster is currently online)
          $users = db_query('SELECT DISTINCT(uid), MAX(timestamp) AS max_timestamp FROM {sessions} WHERE timestamp >= %d AND uid = %d GROUP BY uid ORDER BY max_timestamp DESC', $calc, $uid);
          $total_users = db_num_rows($users);

          $is_active = false;
          if ($total_users == 1)
            $is_active = true;
          $useronline_list["'".$uid."'"] = $is_active;
        }
        return $useronline_list["'".$uid."'"];
    }
  }
}


/* Reverse order, depending on their forum depth */
function uieforum_sort_forums_for_recounts($a, $b)
{
  $a_Obj = $a[0];
  $b_Obj = $b[0];

  $a_Depth = $a[1];
  $b_Depth = $b[1];

  if ($a_Depth == $b_Depth)
  {
    return 0;
  }
  return ($a_Depth < $b_Depth) ? 1 : -1;
}
